// 2006-02-25 programmeerimisvistlus
// lesanne: KASUTAJAGRUPID
// Autor: Ahto Truu
// Testitud: GCC 3.2.3 / MinGW

#include <fstream>
#include <map>
#include <set>
#include <queue>
using namespace std;

const char *SIS = "grp.sis";
const char *VAL = "grp.val";

map<int, set<int> > grp; // gruppide graaf: liige -> grupid

int main() {

    // loeme sisendi
    ifstream sis(SIS);
    int n, m, g, x, k;
    sis >> n; // gruppide arv
    for (int i = 0; i < n; ++i) {
        sis >> g >> m; // grupi ID ja suurus
        for (int j = 0; j < m; ++j) {
            sis >> x; // grupi liige
            // kasutaja vi grupp x kuulub gruppi g
            grp[x].insert(g);
        }
    }
    sis >> k; // uuritav kasutaja

    // leiame vastuse graafi laiuti lbimisega
    set<int> s;
    queue<int> q;
    q.push(k);
    while (!q.empty()) {
        int x = q.front();
        for (set<int>::iterator i = grp[x].begin(); i != grp[x].end(); ++i)
            if (s.count(*i) == 0) {
                s.insert(*i);
                q.push(*i);
            }
        q.pop();
    }

    // vljastame tulemuse
    ofstream val(VAL);
    val << s.size() << endl;
    for (set<int>::iterator i = s.begin(); i != s.end(); ++i) {
        if (i != s.begin())
            val << " ";
        val << *i;
    }
    val << endl;

    return 0;
}
