#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "grp.sis";
const char *OUT = "grp.val";
const char *HINT = "grp.xxx";

void ERR(const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("400\nError: ");
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

void OK(int n, const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("200\nScore: %d\nError: ", n);
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

int n1, n2, x1, x2;
char s[10 + 10];

int main() {
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);

    if (fscanf(hint, "%d", &n1) != 1)
        ERR("Viga vihjefaili lugemisel");
    if (fscanf(out, "%d", &n2) != 1)
        OK(0, "Viga vljundfaili lugemisel");
    if (n1 != n2)
        OK(0, "Vale gruppide arv %d", n2);

    for (int i = 0; i < n1; ++i) {
        if (fscanf(hint, "%d", &x1) != 1)
            ERR("Viga vihjefaili lugemisel");
        if (fscanf(out, "%d", &x2) != 1)
            if (feof(out))
                OK(0, "Enneaegne vljundfaili lpp");
            else
                OK(0, "Viga vljundfaili lugemisel");
        if (x1 != x2)
            OK(0, "Vale grupp %d vi puuduv grupp %d", x2, x1);
    }

    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed smbolid vljundfaili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");
    OK(100, "OK");
}
