{ 2006-02-25 programmeerimisvistlus                                        }
{ lesanne: NELINURGA VRVIMINE                                             }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'neli.sis';                                    { sisendfaili nimi }
   valf = 'neli.val';                                   { vljundfaili nimi }

type
   punkt = record
      x, y : real;
   end;

{ arvutab vektorite ab ja ac vektorkorrutise (pikkuse (koos mrgiga))       }
function vk(a, b, c : punkt) : real;
begin
   vk := (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
end;

{ arvutab kolmnurga abc pindala                                             }
function kp(a, b, c : punkt) : real;
begin
   kp := abs(vk(a, b, c)) / 2;
end;

{ arvutab nelinurga abcd pindala                                            }
function np(a, b, c, d : punkt) : real;
begin
   np := abs(vk(a, b, d) + vk(c, d, b)) / 2;
end;

{ kontrollib, kas sirge ab ja lik cd likuvad                              }
{ kui jah, salvestab likepunkti koordinaadid muutujasse p                  }
function lk(a, b, c, d : punkt; var p : punkt) : boolean;
var r : real;
begin
   if vk(a, b, c) * vk(a, b, d) <= 0 then begin
      lk := true;
      r := vk(a, c, d) / (vk(a, c, b) + vk(a, b, d));
      p.x := a.x + r * (b.x - a.x); p.y := a.y + r * (b.y - a.y);
   end else begin
      lk := false;
   end;
end;

var
   f : text;
   p : array [1..4] of punkt;                             { nelinurga tipud }
   a, b : punkt;                                        { sirge kaks punkti }
   sl : array [1..4] of boolean;            { milliseid klgi sirge likab? }
   lp : array [1..4] of punkt;     { likepunktide koordinaadid, kui likab }
   s1, s2 : real;                                          { osade pindalad }
   i : integer;

begin
   { === loeme sisendandmed === }
   assign(f, sisf); reset(f);
   for i := 1 to 4 do
      readln(f, p[i].x, p[i].y);
   readln(f, a.x, a.y);
   readln(f, b.x, b.y);
   close(f);

   { === tuvastame sirge likumised nelinurga klgedega === }
   for i := 1 to 4 do
      sl[i] := lk(a, b, p[i], p[i mod 4 + 1], lp[i]);

   { === leiame pindalad === }

   { "raligatud" osa }
   s1 := -1;

   { kui likab kaht vastasklge, jagab kaheks nelinurgaks }
   for i := 1 to 2 do
      if sl[i] and sl[i + 2] then
         s1 := np(lp[i], p[i + 1], p[i + 2], lp[i + 2]);

   { kui likab kaht lhisklge, jagab kolmnurgaks ja viisnurgaks}
   if s1 = -1 then
      for i := 1 to 4 do
         if sl[i] and sl[i mod 4 + 1] then
            s1 := kp(lp[i], p[i mod 4 + 1], lp[i mod 4 + 1]);

   { teine osa on terve nelinurk miinus esimene }
   s2 := np(p[1], p[2], p[3], p[4]) - s1;

   { === vljastame vastuse === }
   assign(f, valf); rewrite(f);
   if s1 > s2 then begin
      writeln(f, s1 :0:3);
      writeln(f, s2 :0:3);
   end else begin
      writeln(f, s2 :0:3);
      writeln(f, s1 :0:3);
   end;
   close(f);
end.
