#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "ol.sis";
const char *OUT = "ol.val";
const char *HINT = "ol.xxx";

void ERR(const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("400\nError: ");
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

void OK(int n, const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("200\nScore: %d\nError: ", n);
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r' || s[i] == ' '))
        s[i--] = 0;
    return s;
}

char s1[2 * 333 + 255 + 10], s2[2 * 333 + 255 + 10];
int n = 0;
char s[10 + 10];

int main() {
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);
    while (fgets(s1, sizeof(s1), hint)) {
        ++n;
        if (!fgets(s2, sizeof(s2), out))
            OK(0, "Enneaegne vljundfaili lpp");
        if (strcmp(trim(s1), trim(s2)) != 0)
            OK(0, "Vale vastus real %d", n);
    }
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read vljundfaili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");
    OK(100, "OK");
}
