// 2006-02-25 programmeerimisvistlus
// lesanne: RNGASSRK
// Autor: Margus Niitsoo
// Testitud: GCC 3.2.3 / MinGW

// Algoritm, mis valib igal sammul suurima valjuvate kaartega tipu eemaldamiseks

#include <stdio.h>

int tipud[101];         // Kasutatud tippude indeksite loetelu
int tipustservi[101];   // Servi, mis lahtuvad tipust i
int adjlst[101][101];   // Naabrusloendite jarjend
int jargiservi[101];    // Servi, mis pole veel maha tommatud 

int n;                  // Servade arv

int servad[3001][2];      // Servade loetelu
char servmaas[3001];      // Kas see serv on juba maha voetud (kui mitu korda)

int loika[101];         // Loigatavad rongad

int main(void)
{
    FILE * sis, *val;
    int i, k, a, b;
    int t, m, max, ind;
    
    // Algvaartusta muutujad
    for (i=1;i<101;i++)
        tipustservi[i]=0;

    // Loe sisend
    sis=fopen("rng.sis","rt");

    fscanf(sis,"%i",&n);

    for(i=0;i<n;i++)
    {
       fscanf(sis,"%i %i",&a,&b);
       adjlst[a][tipustservi[a]++]=i;
       adjlst[b][tipustservi[b]++]=i;
       servad[i][0]=a; servad[i][1]=b;
       servmaas[i]=0;
    }

    fclose(sis);

    // Kirjuta yles kasutatud tipud
    t=0;
    for(i=1;i<101;i++)
        if (tipustservi[i]!=0)
            tipud[t++]=i;

    // Kopeeri tipustservi jargiservi-sse
    for(i=1;i<101;i++)
        jargiservi[i]=tipustservi[i];

    m=0;
    while (1)
    {
        // Leia maksimaalse servade arvuga tipp
        max=0; ind=-1;
        for(i=0;i<t;i++)
            if (jargiservi[tipud[i]]>max)
            {
                ind=tipud[i]; max=jargiservi[ind];
            }

        // Kui servi enam pole, lopeta too
        if (max==0) break;

        // Loika valitud tipp
        loika[m++]=ind;

        // Eemalda temaga seotud servad
        for(i=0;i<tipustservi[ind];i++)
        {
            k=adjlst[ind][i];
            if (!servmaas[k])
            {
                jargiservi[servad[k][0]]--;
                jargiservi[servad[k][1]]--;
                servmaas[k]=1;
            }
        }
    }

    // Valjasta tulemus
    val=fopen("rng.val","wt");
    fprintf(val,"%i\n",m);
    
    if (m>0)
    {
        fprintf(val,"%i",loika[0]);
        for(i=1;i<m;i++)
            fprintf(val," %i",loika[i]);
        fprintf(val,"\n");
    }
    
    fclose(val);

    return 0;
}
