// 2006-02-25 programmeerimisvistlus
// lesanne: RNGASSRK
// Autor: Margus Niitsoo
// Testitud: GCC 3.2.3 / MinGW

// Labivaatus tipphaaval - DFS+ID-ga
// Igal sammul tomba maha kas tipp ise voi koik ta naabrid
#include <stdio.h>

int tipud[101];         // Kasutatud tippude indeksite loetelu
int tipustservi[101];   // Servi, mis lahtuvad tipust i
int adjlst[101][101];   // Naabrusloendite jarjend - tipuindeksid
char tippmaas[101];     // Kas see tipp on juba kasutatud

int n;                  // Servade arv
int t;                  // Tippude arv
int piir;               // Mitu tippu voib maha tommata

int servad[3001][2];      // Servade loetelu

int loika[101];         // Loigatavad rongad

char otsi(int nd,int cnt)
{
    int i, k;

    // Kui oleme lubatud hulga tippe maha tommanud
    if (cnt==piir)
    {
        // Vaata, kas on veel servi
        for(i=0;i<n;i++)
            if (!tippmaas[servad[i][0]] && !tippmaas[servad[i][1]]) break;

        // Kontrolli, kas tsuklit murti voi ei
        if (i==n) return 1; 
        else return 0;
    }

    k=tipud[nd];

    // Kui see tipp on juba maha tommatud, mine edasi
    if (tippmaas[k])
        return otsi(nd+1,cnt);

    // Tomba maha ja otsi edasi
    loika[cnt]=k;
    tippmaas[k]=1;
    if (otsi(nd+1,cnt+1)) return 1;
    tippmaas[k]=0;

    // Tomba naabrid maha
    for(i=0;i<tipustservi[k];i++)
    {
        if (tippmaas[adjlst[k][i]]==0) 
            loika[cnt++]=adjlst[k][i];

        tippmaas[adjlst[k][i]]++;
    }

    // Otsi uuesti
    if (cnt<=piir)
        if (otsi(nd+1,cnt)) return 1;

    // Pane naabrid tagasi
    for(i=0;i<tipustservi[k];i++)
        tippmaas[adjlst[k][i]]--;

    return 0;
}

int main(void)
{
    FILE * sis, *val;
    int i, a, b;

    // Algvaartusta muutujad
    for (i=1;i<101;i++)
    {
        tipustservi[i]=0;
        tippmaas[i]=0;
    }

    // Loe sisend
    sis=fopen("rng.sis","rt");

    fscanf(sis,"%i",&n);

    for(i=0;i<n;i++)
    {
        fscanf(sis,"%i %i",&a,&b);
        adjlst[a][tipustservi[a]++]=b;
        adjlst[b][tipustservi[b]++]=a;
        servad[i][0]=a; servad[i][1]=b;
    }

    fclose(sis);

    // Kirjuta yles kasutatud tipud
    t=0;
    for(i=1;i<101;i++)
        if (tipustservi[i]!=0)
            tipud[t++]=i;

    // Otsii jarjest kasvava pikkusega lahendusi
    if (n>0)
    {
        piir=1;
        while(!otsi(0,0)) piir++;
    }
    else piir=0;

    // Valjasta tulemus
    val=fopen("rng.val","wt");
    fprintf(val,"%i\n",piir);

    if (piir>0)
    {
        fprintf(val,"%i",loika[0]);
        for(i=1;i<piir;i++)
            fprintf(val," %i",loika[i]);
        fprintf(val,"\n");
    }

    fclose(val);

    return 0;
}
