// 2006-02-25 programmeerimisvistlus
// lesanne: RNGASSRK
// Autor: Margus Niitsoo
// Testitud: GCC 3.2.3 / MinGW

// Labivaatus tipphaaval - sama nagu tipp.c aga puud trimmitakse pisut
#include <stdio.h>

int tipud[101];         // Kasutatud tippude indeksite loetelu
int tipustservi[101];   // Servi, mis lahtuvad tipust i
int adjlst[101][101];   // Naabrusloendite jarjend
int jargiservi[101];    // Servi, mis pole veel maha tommatud 

int n;                  // Servade arv
int t;                  // Tippude arv
int piir;               // Mitu tippu voib maha tommata

int servad[3001][2];      // Servade loetelu
char servmaas[3001];      // Kas see serv on juba maha voetud (kui mitu korda)
int servi;              // Mitu serva on veel alles

int loika[101];         // Loigatavad rongad

char valitud[101];       // Kas on uks valitud suurtest

char otsi(int nd,int cnt)
{
    int i, k, max, ind, sum;
    
    // Me oleme valinud nii palju, kui tohime
    if (cnt==piir)
    {
        // Lopeta too olenevalt jargi olevate servade arvust
        if (servi==0) return 1;
        else return 0;
    }

    // Margi koik mittevalituks
    for(i=nd;i<t;i++)
        valitud[i]=0;

    // Leia (piir-cnt) suurima jargiservi vaartuse summa
    sum=0;
    for(k=0;k<piir-cnt;k++)
    {
        // Leia suurim mittevalitud vaartus
        max=0; ind=-1;
        for(i=nd;i<t;i++)
            if (!valitud[i] && jargiservi[tipud[i]]>max)
            {
                ind=i; max=jargiservi[tipud[i]];
            }

        // Suurenda maksimumi vastavalt vajadusele
        if (max==0 || sum>=servi) break;
        else 
        {
            sum=sum+max;
            valitud[ind]=1;
        }
    }

    // Kui eemaldada on rohkem, kui me saaksime, lopeta too
    if (servi>sum) return 0;

    // Proovi see tipp votta
    k=tipud[nd];

    if (jargiservi[k]>0)
    {
        for(i=0;i<tipustservi[k];i++)
        {
            jargiservi[servad[adjlst[k][i]][0]]--;
            jargiservi[servad[adjlst[k][i]][1]]--;

            if (servmaas[adjlst[k][i]]==0) servi--;
            servmaas[adjlst[k][i]]++;
        }

        loika[cnt]=k;
        if (otsi(nd+1,cnt+1)) return 1;

        for(i=0;i<tipustservi[k];i++)
        {
            jargiservi[servad[adjlst[k][i]][0]]++;
            jargiservi[servad[adjlst[k][i]][1]]++;

            servmaas[adjlst[k][i]]--;
            if (servmaas[adjlst[k][i]]==0) servi++;
        }
    }

    // Proovi seda tippu vahele jatta
    if (piir-cnt<t-nd)
        if (otsi(nd+1,cnt)) return 1;

    return 0;
}

int main(void)
{
    FILE * sis, *val;
    int i, k, a, b, buf;

    // Algvaartusta muutujad
    for (i=1;i<101;i++)
        tipustservi[i]=0;

    // Loe sisend
    sis=fopen("rng.sis","rt");

    fscanf(sis,"%i",&n);
    servi=n;

    for(i=0;i<n;i++)
    {
        fscanf(sis,"%i %i",&a,&b);
        adjlst[a][tipustservi[a]++]=i;
        adjlst[b][tipustservi[b]++]=i;
        servad[i][0]=a; servad[i][1]=b;
        servmaas[i]=0;
    }

    fclose(sis);

    // Kirjuta yles kasutatud tipud
    t=0;
    for(i=1;i<101;i++)
        if (tipustservi[i]!=0)
            tipud[t++]=i;

    // Sorteeri tipud kahanevalt nendest valjuvate servade arvu jargi
    for(i=2;i<t;i++)
    {
        buf=tipud[i]; k=i-1;
        while (k>=0 && tipustservi[tipud[k]]<tipustservi[buf])
        {
            tipud[k+1]=tipud[k];
            k--;
        }
        tipud[k+1]=buf;
    }       

    // Kopeeri tipustservi jargiservi-sse
    for(i=1;i<101;i++)
        jargiservi[i]=tipustservi[i];

    // Otsii jarjest kasvava pikkusega lahendusi
    if (n>0)
    {
        piir=1;
        while(!otsi(0,0)) piir++;
    }
    else piir=0;

    // Valjasta tulemus
    val=fopen("rng.val","wt");
    fprintf(val,"%i\n",piir);

    if (piir>0)
    {
        fprintf(val,"%i",loika[0]);
        for(i=1;i<piir;i++)
            fprintf(val," %i",loika[i]);
        fprintf(val,"\n");
    }
    
    fclose(val);

    return 0;
}
