// 2006-02-25 programmeerimisvistlus
// lesanne: RNGASSRK
// Autor: Margus Niitsoo
// Testitud: GCC 3.2.3 / MinGW

// Labivaatus tipphaaval - DFS+ID-ga erinevate maha tombamiste proovimine
#include <stdio.h>

int tipud[101];         // Kasutatud tippude indeksite loetelu
int tipustservi[101];   // Servi, mis lahtuvad tipust i
int adjlst[101][101];   // Naabrusloendite jarjend
int jargiservi[101];    // Servi, mis pole veel maha tommatud 

int n;                  // Servade arv
int t;                  // Tippude arv
int piir;               // Mitu tippu voib maha tommata

int servad[3001][2];      // Servade loetelu
char servmaas[3001];      // Kas see serv on juba maha voetud (kui mitu korda)

int loika[101];         // Loigatavad rongad

char otsi(int nd,int cnt)
{
    int i, k;

    if (cnt==piir)
    {
        // Vaata, kas on veel servi
        for(i=0;i<n;i++)
            if (servmaas[i]==0) break;

        // Kontrolli, kas tsuklit murti voi ei
        if (i==n) return 1; 
        else return 0;
    }

    k=tipud[nd];

    // Vaata kas on motet seda tippu valida
    if (jargiservi[k]>0)
    {
        // Tomba selle servad maha
        for(i=0;i<tipustservi[k];i++)
        {
            jargiservi[servad[adjlst[k][i]][0]]--;
            jargiservi[servad[adjlst[k][i]][1]]--;
            servmaas[adjlst[k][i]]++;
        }

        // Otsi edasi
        loika[cnt]=k;
        if (otsi(nd+1,cnt+1)) return 1;

        // Pane servad tagasi
        for(i=0;i<tipustservi[k];i++)
        {
            jargiservi[servad[adjlst[k][i]][0]]++;
            jargiservi[servad[adjlst[k][i]][1]]++;
            servmaas[adjlst[k][i]]--;
        }
    }

    // Proovi seda tippu vahele jatta
    if (piir-cnt<t-nd)
        if (otsi(nd+1,cnt)) return 1;

    return 0;
}

int main(void)
{
    FILE * sis, *val;
    int i, a, b;

    // Algvaartusta muutujad
    for (i=1;i<101;i++)
        tipustservi[i]=0;

    // Loe sisend
    sis=fopen("rng.sis","rt");

    fscanf(sis,"%i",&n);

    for(i=0;i<n;i++)
    {
        fscanf(sis,"%i %i",&a,&b);
        adjlst[a][tipustservi[a]++]=i;
        adjlst[b][tipustservi[b]++]=i;
        servad[i][0]=a; servad[i][1]=b;
        servmaas[i]=0;
    }

    fclose(sis);

    // Kirjuta yles kasutatud tipud
    t=0;
    for(i=1;i<101;i++)
        if (tipustservi[i]!=0)
            tipud[t++]=i;

    // Kopeeri tipustservi jargiservi-sse
    for(i=1;i<101;i++)
        jargiservi[i]=tipustservi[i];

    // Otsi jarjest kasvava pikkusega lahendusi
    if (n>0)
    {
        piir=1;
        while(!otsi(0,0)) piir++;
    }
    else piir=0;

    // Valjasta tulemus
    val=fopen("rng.val","wt");
    fprintf(val,"%i\n",piir);

    if (piir>0)
    {
        fprintf(val,"%i",loika[0]);
        for(i=1;i<piir;i++)
            fprintf(val," %i",loika[i]);
        fprintf(val,"\n");
    }

    fclose(val);

    return 0;
}
