#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "rng.sis";
const char *OUT = "rng.val";
const char *HINT = "rng.xxx";

const int maxn = 200;
const int maxr = 100;

void ERR(const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("400\nError: ");
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

void OK(int n, const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("200\nScore: %d\nError: ", n);
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

int n;
int e[maxn][2];
int m1, m2, x;
bool v[1 + maxr];
bool c[1 + maxr];

char s[10 + 10];

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili avamisel");
    if (fscanf(in, "%d", &n) != 1)
        ERR("Viga sisendfaili lugemisel");
    for (int i = 0; i < n; ++i) {
        if (fscanf(in, "%d %d", &e[i][0], &e[i][1]) != 2)
            ERR("Viga sisendfaili lugemisel");
        v[e[i][0]] = true;
        v[e[i][1]] = true;
    }
    fclose(in);

    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    if (fscanf(hint, "%d", &m1) != 1)
        ERR("Viga vihjefaili lugemisel");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);
    if (fscanf(out, "%d", &m2) != 1)
        OK(0, "Viga vljundfaili lugemisel");
    if (m1 != m2)
        OK(0, "Vale rngaste arv %d", m2);
    for (int i = 0; i < m2; ++i) {
        if (fscanf(out, "%d", &x) != 1)
            if (feof(out))
                OK(0, "Enneaegne vljundfaili lpp");
            else
                OK(0, "Viga vljundfaili lugemisel");
        if (x < 1 || x > maxr)
            OK(0, "Lubamatu rnga number %d", x);
        if (!v[x])
            OK(0, "Tundmatu rngas %d", x);
        if (c[x])
            OK(0, "Korduv rngas %d", x);
        c[x] = true;
    }
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed smbolid vljundfaili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    for (int i = 0; i < n; ++i)
        if (!c[e[i][0]] && !c[e[i][1]])
            OK(0, "Rngad %d ja %d lahutamata", e[i][0], e[i][1]);

    OK(100, "OK");
}
